function loginController($scope, $apiCaller, $cordovaDevice, $socketService, $ionicPopup, $ionicLoading, $cordovaBackgroundGeolocation, $ionicPlatform, $databaseService, $driverAppService, $interval, $cordovaGeolocation, $http) {

    $scope.options = {};
    $scope.password = '';
    $scope.error_login = '';
    $scope.loginInput = false;
    $scope.version = "0.0.9";
    var confirmPopup = null;

    $scope.init = function () {
      $ionicLoading.show({
          templateUrl: 'partials/loading.html',
          noBackdrop: true
      });
        $http({
            method: 'GET',
            url: 'http://services.mgetaxi.com/appversion.php?platform=android&type=driver'
        }).then(function successCallback(response) {
                if (response.data == $scope.version) {
                    $scope.execute();
                } else {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: 'New Update',
                        template: 'Your app is needed to be updated.',
                        okText: 'UPDATE', // String (default: 'OK'). The text of the OK button.

                    }).then(function () {
                        window.open('market://details?id=com.mgetaxi.driver', '_system');
                        navigator.app.exitApp();
                    })
                }
            },
            function errorCallback(response) {

            });
    }

    $scope.execute = function () {

        localStorage.setItem('status', 1);
        registerBackButtonCallBackFunction($scope.exitApp);
        $scope.networkState = navigator.connection.type;
        if ($scope.networkState != 'none') {
            var gpschecker = $interval(function () {
                cordova.plugins.diagnostic.isLocationEnabled(function (enabled) {

                    if (enabled) {

                        var posOptions = {
                            timeout: 10000,
                            enableHighAccuracy: false
                        };

                        $cordovaGeolocation
                            .getCurrentPosition(posOptions)
                            .then(function (position) {
                                sessionStorage.setItem('currentlat', position.coords.latitude);
                                sessionStorage.setItem('currentlng', position.coords.longitude);
                                $scope.loginInput = true;
                                $interval.cancel(gpschecker);
                                confirmPopup = null;
                                $ionicLoading.hide();
                            }, function (err) {
                                console.log(err);
                            });

                    } else {
                        $ionicLoading.hide();
                        if (!confirmPopup) {
                            confirmPopup = $ionicPopup.confirm({
                                title: 'App  Permission',
                                template: '<label>Allow App to access your location.</label>',
                                okText: 'ALLOW',
                                okType: 'button-positive button-clear',
                                cancelText: 'EXIT',
                                cancelType: 'button-assertive button-clear'
                            });
                            confirmPopup.then(function (res) {
                                if (res) {
                                    $ionicLoading.show({
                                        templateUrl: 'partials/loading.html',
                                        noBackdrop: true
                                    });
                                    cordova.plugins.diagnostic.switchToLocationSettings();
                                } else {
                                    $scope.exitApp();
                                }
                            });
                        }
                    }
                }, function (error) {
                    console.log();
                });

            }, 300);

        } else {

            $ionicLoading.hide();
            var alertPopup = $ionicPopup.alert({
                title: 'Network not available',
                template: 'turn on your 3G/4G or wifi settings'
            });
            alertPopup.then(function () {
                $scope.exitApp();
            });
        }
    }

    $scope.triggerKey = function ($val) {

        if ($scope.password.length < 6) {
            $scope.password += '' + $val;
            $scope.error_login = '';
        }
        if ($scope.password.length > 5) {
            $ionicLoading.show({
                templateUrl: 'partials/loading.html',
                noBackdrop: true
            });
            var device_info = $cordovaDevice.getDevice();
            $apiCaller.create(
                "auths", {
                    "session_type": "D",
                    "device_id": device_info.uuid,
                    "user_name": device_info.uuid,
                    "password": $scope.password
                },
                function (response) {

                    $ionicLoading.hide();
                    if (response.status == 201) {
                        if (response.data.cab != null) {

                            localStorage.setItem("cab", JSON.stringify(response.data.cab));
                            localStorage.setItem("appAccessObj", JSON.stringify(response.data));
                            localStorage.setItem("access_token", response.data.access_token);
                            localStorage.setItem("profile", JSON.stringify(response.data.profile));
                            localStorage.setItem("session_id", response.data.session_id);
                            $socketService.socket_init();
                            window.location = "#/main"
                        } else {
                            $scope.error_login = "Login Failed! No taxi registered to you!"
                            $scope.password = '';
                            $scope.$apply();
                        }
                    } else {

                        $scope.error_login = 'Invalid Security Code';
                        $scope.password = '';
                        $scope.$apply();
                    }

                }
            );
        }

    }

    $scope.exitApp = function () {
        navigator.app.exitApp();
    }

    $scope.clearPassword = function () {
        $scope.password = '';
        $scope.error_login = '';
    }

    $scope.mobileInformation = function () {
        var device_info = $cordovaDevice.getDevice();
        var temp = '<h5>Platform: ' + device_info.platform + '</h5>' + '<h5>Version: ' + device_info.version + '</h5>' + '<h5>Device UUID: ' + device_info.uuid + '</h5>' + '<h5>Brand: ' + device_info.manufacturer + '</h5>' + '<h5>Model: ' + device_info.model + '</h5>';
        var alertPopup = $ionicPopup.alert({
            title: 'Device information',
            template: temp,
            okType: 'button-positive button-clear',
        });
    }

}
