function mainController($scope, $ionicPopup, $cordovaGeolocation, $cordovaBackgroundGeolocation, $cordovaVibration, $cordovaStatusbar, $cordovaDevice, $cordovaLocalNotification, $leafletService, $moveJSService, $bgGeolocService, $timeout, $interval, $databaseService, $cordovaNativeAudio, $driverAppService, $ionicLoading, $ionicModal, $ionicActionSheet, $socketService, $apiCaller, $rootScope, $cordovaNetwork) {

    $scope.data = [];
    $scope.request = [];
    $scope.displayTimeLimit = 60;
    $scope.displayCounter = $scope.displayTimeLimit;
    $scope.display;
    $scope.queueTimeLimit = 1000;
    $scope.passengerTimeLimit = 60;
    $scope.queue;
    $scope.notif = true;
    $scope.map = null;
    $scope.newbook = false;
    $scope.passenger = [];
    $scope.passengerLocation = [];
    $scope.destinationLocation = [];
    $scope.passMarker;
    $scope.driverMarker;
    $scope.destinationMarker;
    $scope.currentPassengerUserId = 0;
    $scope.showToggle = true;
    $scope.requestExpiry = 360;
    $scope.currentPassenger;
    $scope.smsTemplate;
    $scope.requestExpireTimer = true;

    $scope.cabStatus = 0;
    var EMPTY = 0;
    var PICKUP = 1;
    var TRAVEL = 2;


    $scope.init = function () {
        registerBackButtonCallBackFunction(function () {});

        $socketService.set_socket_response('new_booking', $scope.fetchBookingDataFromServer);
        $socketService.set_socket_response('cancel_booking', $scope.bookingCancelledByPassenger);
        $scope.loadProfile();
        $scope.loadMap();
        $moveJSService.loadActivity("main", function () {

            $ionicLoading.show({
                templateUrl: 'partials/loading.html'
            });

            // initialize default listener to receive new booking
            $databaseService.initializeDB();
            $timeout($scope.startQueueingBookingList, 2000);
            $driverAppService.fetchLocationInfo(
                function () {

                    $scope.pickupCode = $driverAppService.generateDriverCode(localStorage.getItem("location_id"));
                    var location_id = localStorage.getItem("location_id");
                    var obj = {
                        'location_id': location_id,
                        'token': '123'
                    };
                    $scope.startLocalGeolocation();
                    $scope.startBackgroundGeolocation("1");
                    $scope.changeStatus();
                    $ionicLoading.hide();

                },
                function () {
                    localStorage.clear();
                    $ionicLoading.hide();
                    alert('Session Expired!');
                    $socketService.disconnect_socket();
                    navigator.app.exitApp();

                }
            )

        });

        $cordovaNativeAudio.preloadSimple('taxi', 'assets/taxi_whistle.mp3')
            .then(function (msg) {
                console.log(msg);
            }, function (error) {
                console.log(error);
            });

        $cordovaNativeAudio.preloadSimple('tada', 'assets/tada.mp3')
            .then(function (msg) {
                console.log(msg);
            }, function (error) {
                console.log(error);
            });
        $scope.networkMonitoring();
    }



    $scope.networkTheme = "network-online";
    $scope.networkStatus = "";
    $scope.isConnected = true;
    $scope.showNetwork = false;

    $scope.networkMonitoring = function () {
        // listen for Online event
        $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
            var onlineState = networkState;
            $scope.isConnected = true;
            $scope.showNetwork = true;
            $scope.networkTheme = "network-online";
            $scope.networkStatus = "Connected to " + onlineState + " network.";
            $timeout(function () {
                $scope.showNetwork = false;
            }, 3000)
        });

        // listen for Offline event
        $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
            var offlineState = networkState;
            $scope.isConnected = false;
            $scope.showNetwork = true;
            $scope.networkTheme = "network-offline";
            $scope.networkStatus = "Waiting for Network...";
        });

    }

    $scope.loadMap = function () {
        $scope.newbook = false;
        var mapData = {
            mapContainer: 'map',
            icon: 'img/taxi.png',
            size: 45,
            lat: sessionStorage.getItem('currentlat'),
            lng: sessionStorage.getItem('currentlng'),
            zoom: 15,
        };
        $scope.map = $leafletService.loadMap(mapData);
        $scope.driverMarker = $leafletService.addMarker(mapData);
        $scope.driverMarker.addTo($scope.map);
    }

    $scope.profile = [];
    $scope.cab = JSON.parse(localStorage.getItem("cab"));
    $scope.loadProfile = function () {

        $scope.profile = JSON.parse(localStorage.getItem("profile"));



        $scope.cab = JSON.parse(localStorage.getItem("cab"));
        //$scope.company = JSON.parse(localStorage.getItem("company"));
    }

    $scope.driverStatusText = "Available";
    $scope.hiredToggle = [{
        text: " ",
        checked: false
    }];



    $scope.changeStatus = function () {


        var driverstatus = document.getElementById('driver-status');
        var flag = ($scope.hiredToggle[0].checked === true ? "0" : "1");
        var data = {
            status: flag
        };

        $driverAppService.changeDriverStatus(data, function (response) {

            if (response.status == 204) {

                if (flag == 0) {
                    $scope.driverStatusText = "Hired";
                    move(driverstatus).set('background-color', '#0099FF').set('color', '#fff').end();
                    $cordovaStatusbar.styleHex("#0099FF");
                } else {
                    $scope.driverStatusText = "Available";
                    move(driverstatus).set('background-color', '#33CC2B').set('color', '#fff').end();
                    $cordovaStatusbar.styleHex("#33CC2B");

                }
                $scope.startBackgroundGeolocation(flag);

            }
        });

    }

    $scope.statusTheme = '';
    $scope.statusMessage = '';
    $scope.showStatus = false;
    $scope.statusIcon = '';

    $scope.statusTrouble = function () {
        if ($scope.isConnected) {

            if ($scope.statusMessage != 'You are in trouble!') {

                $ionicLoading.show({
                    template: 'Sending trouble status...',
                    noBackdrop: true
                });

                var data = {
                    status: '4'
                };

                $driverAppService.changeDriverStatus(data, function (response) {

                    if (response.status == 204) {
                        $scope.showStatus = true;
                        $cordovaStatusbar.styleHex("#333");
                        $scope.statusTheme = 'status-trouble';
                        $scope.statusIcon = "ion-wrench";
                        $scope.statusMessage = 'You are in trouble!';
                        $scope.startBackgroundGeolocation("4");
                        $scope.showEmergencyOrTrouble = true;
                        $ionicLoading.hide();
                        $ionicLoading.show({
                            template: 'Status sent.',
                            noBackdrop: true
                        });

                        $timeout(function () {
                            $ionicLoading.hide();
                        }, 2000);

                    } else {
                        $ionicLoading.hide();
                    }
                });
            }
        } else {
            $ionicLoading.show({
                template: 'No network available in your area. Please try again later..',
                noBackdrop: true
            });
            $timeout(function () {
                $ionicLoading.hide();
            }, 4000)
        }
    }

    $scope.statusDanger = function () {
        if ($scope.statusMessage != 'You are in danger!') {
            $cordovaVibration.vibrate(200);
            $timeout(function () {
                $cordovaVibration.vibrate(200);
            }, 500);
            $ionicLoading.show({
                template: 'Sending danger status...',
                noBackdrop: true
            });

            var data = {
                status: '5'
            };

            $driverAppService.changeDriverStatus(data, function (response) {

                if (response.status == 204) {
                    $scope.showStatus = true;
                    $cordovaStatusbar.styleHex("#ef473a");
                    $scope.statusTheme = 'status-danger';
                    $scope.statusIcon = "ion-alert-circled";
                    $scope.statusMessage = 'Your are in danger!';
                    $scope.startBackgroundGeolocation("5");
                    $scope.showEmergencyOrTrouble = true;
                    $ionicLoading.hide();
                    $ionicLoading.show({
                        template: 'Status sent.',
                        noBackdrop: true
                    });

                    $timeout(function () {
                        $ionicLoading.hide();
                    }, 2000);
                } else {
                    $ionicLoading.hide();
                }
            });
        }
    }

    $scope.startBackgroundGeolocation = function (status) {

        var device_info = $cordovaDevice.getDevice();
        var obj = {
            device_id: device_info.uuid,
            access_token: localStorage.getItem("access_token"),
            status: status,
            location_id: localStorage.getItem("location_id")
        };
        $bgGeolocService.startBackgroundGeolocation(obj);

    }

    $scope.startLocalGeolocation = function () {

        var watchOptions = {
            frequency: 15 * 60 * 1000,
            timeout: 1 * 60 * 1000,
            enableHighAccuracy: false
        };

        $cordovaGeolocation.watchPosition(watchOptions).then(null,
            function (err) {
                console.log(err);
                $scope.lol = JSON.stringify(err);
            },
            function (position) {
                $scope.lol = "lat:" + position.coords.latitude + "  lng:" + position.coords.longitude
                sessionStorage.setItem('currentlat', position.coords.latitude);
                sessionStorage.setItem('currentlng', position.coords.longitude);


                var location_data = {
                    location_id: localStorage.getItem('location_id'),
                    lat: position.coords.latitude,
                    lng: position.coords.longitude,
                    status: localStorage.getItem('status')
                };

                // sends geo location to passenger
                if ($scope.currentPassengerUserId > 0)
                    location_data.user_id = $scope.currentPassengerUserId;

                //socket to send driver location to server
                $socketService.send_location_to_server(location_data);



                var mapData = {
                    icon: 'img/taxi.png',
                    size: 45,
                    lat: position.coords.latitude,
                    lng: position.coords.longitude,
                };


                if ($scope.cabStatus == PICKUP) {
                    $scope.map.fitBounds([[position.coords.latitude, position.coords.longitude], $scope.passengerLocation], {
                        padding: [50, 50]
                    });

                } else if ($scope.cabStatus == EMPTY) {

                    mapData = {
                        mapContainer: $scope.map,
                        icon: 'img/taxi.png',
                        size: 45,
                        lat: position.coords.latitude,
                        lng: position.coords.longitude,
                        zoom: 15
                    };

                    $leafletService.setCenter(mapData);
                } else if ($scope.cabStatus == TRAVEL) {


                    $scope.map.fitBounds([[position.coords.latitude, position.coords.longitude], $scope.destinationLocation], {
                        padding: [50, 50]
                    });

                    mapData = {
                        icon: 'img/taxi2.png',
                        size: 45,
                        lat: position.coords.latitude,
                        lng: position.coords.longitude,
                    };

                }



                if ($scope.driverMarker != undefined)
                    $leafletService.removeMarker($scope.map, $scope.driverMarker);

                $scope.driverMarker = $leafletService.addMarker(mapData);
                $scope.driverMarker.addTo($scope.map);


            });
    }

    $scope.startQueueingBookingList = function () {

        $scope.queue = $interval(function () {
            $scope.fetchBookingDataFromLocal();
        }, $scope.queueTimeLimit);

    }

    $scope.fetchBookingDataFromServer = function (data) {
        $driverAppService.fetchBookingfromServer(data,
            $databaseService.addBookingData,
            function () {
                console.log('error');
            });
    }

    $scope.fetchBookingDataFromLocal = function () {
        $databaseService.getBookingData($scope.displayBook, $scope.emptyBook);
    }

    $scope.emptyBook = function () {
        $scope.request = [];
        $interval.cancel($scope.queue);
        $scope.startQueueingBookingList();
        $scope.newbook = false;
        $interval.cancel($scope.expiretimer);
        $scope.requestExpireTimer = true;

    }

    $scope.displayBook = function (data) {

        $scope.newbook = true;
        $interval.cancel($scope.queue);
        $scope.request = data;
        $driverAppService.returnFromHomeScreen();
        if ($scope.notif) {
            $cordovaNativeAudio.play('taxi');
            $cordovaVibration.vibrate(3000);
        } else {
            $scope.notif = true;
        }

        $scope.displayCounter = $scope.displayTimeLimit;
        $scope.display = $interval(function () {
            $scope.displayCounter--;
            if ($scope.displayCounter == 0) {
                $interval.cancel($scope.display);
                $scope.nextBooking(true);
            }
        }, 1000);

    }


    /*this function cancels the booking by time expire and clicking the next button*/
    $scope.nextBooking = function (notif) {

        $interval.cancel($scope.display);
        $scope.notif = notif;
        $databaseService.updateBookingStatus($scope.request[0].booking_id, 2,
            function () {
                //console.log(JSON.stringify($scope.request[0]));
                var booking_details = {
                    status: 2,
                    booking_id: $scope.request[0].booking_id,
                    user_id: $scope.request[0].user_id,
                    location_id: localStorage.getItem('location_id'),
                    r_lat: sessionStorage.getItem('currentlat'),
                    r_lng: sessionStorage.getItem('currentlng'),
                    cab_id: $scope.cab.cab_id
                };
                //alert(JSON.stringify(booking_details));
                $socketService.update_booking_acceptance(booking_details, function (data) {
                    //alert(JSON.stringify(data));
                    //console.log('::update_booking_acceptance -->' + JSON.stringify(data))
                    $scope.request = [];
                    $scope.startQueueingBookingList();
                    $interval.cancel($scope.expiretimer);
                    $scope.requestExpireTimer = true;
                });
            },
            function (e) {
                console.log(e.message);
            });
    }


    $scope.acceptBooking = function (data) {

        $databaseService.updateBookingStatus(data.booking_id, 1,
            function () {
                console.log(JSON.stringify($scope.request[0]));
                var booking_details = {
                    status: 1,
                    booking_id: data.booking_id,
                    user_id: data.user_id,
                    location_id: localStorage.getItem('location_id'),
                    r_lat: sessionStorage.getItem('currentlat'),
                    r_lng: sessionStorage.getItem('currentlng'),
                    cab_id: $scope.cab.cab_id

                };

                //alert(JSON.stringify(booking_details));
                $socketService.update_booking_acceptance(booking_details, function (result) {

                    if ($scope.passMarker != undefined)
                        $leafletService.removeMarker($scope.map, $scope.passMarker);

                    var mapData = {
                        icon: 'img/me.png',
                        size: 45,
                        lat: data.p_lat,
                        lng: data.p_lng,
                    };

                    $scope.passMarker = $leafletService.addMarker(mapData);
                    $scope.passMarker.addTo($scope.map);
                    $scope.passengerLocation = [parseFloat(data.p_lat), parseFloat(data.p_lng)];
                    $scope.targetGeoloc = $scope.passengerLocation;
                    $scope.cabStatus = PICKUP;


                    $interval.cancel($scope.display);
                    $scope.displayCounter = $scope.displayTimeLimit;
                    $scope.newbook = false;
                    $ionicLoading.show({
                        template: '<div class="col" >' +
                            '<img src="' + data.image + '" style="margin:0 auto !important; max-height:65px; border-radius:100%" />' +
                            '</div> ' +
                            '<rating ng-model="' + data.ratings + '" max="5" readonly="true"></rating>' +
                            '<div class="col">' +
                            '<h2>' + data.given_name + ' ' + data.last_name + '</h2>' +
                            '<p>' + data.p_location + '</p>' +
                            '<p>BOOKING ID: ' + data.booking_id + '</p>' +
                            '</div>' +
                            '<div class="col">' +
                            '<ion-spinner icon="dots"></ion-spinner>' +
                            '</div>' +
                            '<div class="col">Waiting for passenger confirmation. </div>'
                    });


                    localStorage.setItem('currentPassenger', JSON.stringify(data));
                    $socketService.set_socket_response('passenger_response', $scope.passengerResponse);
                    $scope.requestExpireTimer = false;
                    $scope.requestExpiryDisplay = $scope.requestExpiry;

                    $scope.expiretimer = $interval(function () {

                        if ($scope.requestExpiryDisplay == 0) {
                            $interval.cancel($scope.expiretimer);

                            var booking_details = {
                                status: 2,
                                booking_id: data.booking_id,
                                user_id: data.user_id,
                                location_id: localStorage.getItem('location_id')
                            };

                            $scope.requestExpiryDisplay = $scope.requestExpiry;
                            $socketService.update_booking_acceptance(booking_details, function (data) {
                                $ionicLoading.hide();
                                $scope.cabStatus = EMPTY;
                                $scope.requestExpireTimer = true;
                                $scope.currentPassengerUserId = 0;
                                $leafletService.removeMarker($scope.map, $scope.passMarker);
                                $scope.request = [];
                                $scope.startQueueingBookingList();

                            });


                        }
                        $scope.requestExpiryDisplay--;
                    }, 1000);




                });
            },
            function (e) {
                console.log(e.message);
            });

    }


    $scope.pickupNav = true;

    $scope.pickUpPassenger = function () {

        var confirmPopup = $ionicPopup.confirm({
            title: 'Reminder',
            template: 'Make sure that you have reach the passengers location',
            okText: 'PICK UP',
            okType: 'button-positive button-clear',
            cancelText: 'BACK',
            cancelType: 'button-positive button-clear'
        });

        confirmPopup.then(function (res) {
            if (res) {

                $scope.closeModal();

                var data = {
                    p_user_id: $scope.currentPassenger.user_id,
                    pickup_code: $scope.pickupCode
                };

                $socketService.pickup_passanger(data);

                $socketService.set_socket_response('pickup_request_sent', function (data) {

                    $ionicLoading.show({
                        template: data.message
                    });

                    $timeout(function () {
                        $ionicLoading.hide()
                    }, 2000);
                });


                $socketService.set_socket_response('passenger_pickup_code_response', $scope.updateTransactionPickup);



            }
        });

    }


    $scope.updateTransactionPickup = function (data) {

        //alert(JSON.stringify(data));

        $cordovaNativeAudio.play('tada');
        $cordovaVibration.vibrate(2000);

        TTS.speak("Pick up successful. You can now proceed to passenger's destination.", function () {
            //alert('success');
        }, function (reason) {
            //alert(reason);
        });


        $ionicPopup.alert({
            title: 'Pick up successful',
            template: "You can now proceed to passenger's destination",
            okType: 'button-positive button-clear'
        }).then(function () {

        });

        var transaction_id = localStorage.getItem('transaction_id');

        var obj = {
            'p_lat': sessionStorage.getItem('currentlat'),
            'p_lng': sessionStorage.getItem('currentlng'),
            'status': '1'
        }

        $driverAppService.updateBookingTransaction(transaction_id, obj,
            function (response) {
                if (response.status == 204) {

                    /*alert(JSON.stringify(response));
                    localStorage.getItem();*/

                    $leafletService.removeMarker($scope.map, $scope.passMarker);
                    //alert(JSON.stringify($scope.currentPassenger));

                    var mapData = {
                        icon: 'img/destination.png',
                        size: 50,
                        lat: $scope.currentPassenger.d_lat,
                        lng: $scope.currentPassenger.d_lng,
                    };
                    $scope.targetLocationDisplay = $scope.currentPassenger.d_location;
                    $scope.destinationMarker = $leafletService.addMarker(mapData);
                    $scope.destinationMarker.addTo($scope.map);
                    $scope.destinationLocation = [parseFloat($scope.currentPassenger.d_lat), parseFloat($scope.currentPassenger.d_lng)];
                    $scope.targetGeoloc = $scope.destinationLocation;
                    $scope.cabStatus = TRAVEL;
                    $scope.pickupNav = false;


                }
            });
    }


    $scope.navigate = function (to) {
        launchnavigator.navigate(
            $scope.targetGeoloc, [parseFloat(sessionStorage.getItem('currentlat')), parseFloat(sessionStorage.getItem('currentlng'))],

            function () {
                //alert("Plugin success");
            },
            function (error) {
                //alert("Plugin error: "+ error);
            });
    }

    $scope.navigateWaze = function () {
        window.location = "waze://?ll=" + parseFloat($scope.targetGeoloc[0]) + "," + parseFloat($scope.targetGeoloc[1]) + "&navigate=yes";
    }


    $scope.updateTransactionDropOff = function () {

        var confirmPopup = $ionicPopup.confirm({
            title: 'Drop off',
            template: 'Are you sure you want to end trip?',
            okText: 'YES',
            okType: 'button-positive button-clear',
            cancelText: 'NO',
            cancelType: 'button-positive button-clear'
        });

        confirmPopup.then(function (res) {

            if (res) {


                var transaction_id = localStorage.getItem('transaction_id');

                var obj = {
                    'd_lat': sessionStorage.getItem('currentlat'),
                    'd_lng': sessionStorage.getItem('currentlng'),
                    'status': '2'
                };

                $driverAppService.updateBookingTransaction(transaction_id, obj,
                    function (response) {
                        if (response.status == 204) {

                            localStorage.setItem('transaction', JSON.stringify(response.data));
                            var data = {
                                p_user_id: $scope.currentPassenger.user_id
                            };
                            $socketService.transaction_done(data);

                            TTS.speak("Transaction complete. Click ok to view transaction summary.", function () {
                                //alert('success');
                            }, function (reason) {
                                //alert(reason);
                            });

                            $ionicPopup.alert({
                                title: 'Transaction complete.',
                                template: "Click ok to view transaction summary",
                                okType: 'button-positive button-clear'

                            }).then(function () {

                                window.location = "#/rating";

                            });

                        }
                    });

            }
            $scope.closeModal();


        });


    }


    $scope.targetLocationDisplay = '';
    $scope.targetGeoloc = [];
    $scope.passengerResponse = function (data) {
        //alert(JSON.stringify(data));
        if (data.status == 1) {
            $scope.showStatus = true;
            $cordovaNativeAudio.play('tada');
            $cordovaVibration.vibrate(2000);
            $ionicPopup.alert({
                title: 'Passenger responded',
                template: "Passenger has selected you. <br/>  Proceed now to passenger's pick up location.",
                okType: 'button-positive button-clear'

            }).then(function () {

            });

            TTS.speak("Passenger has selected you.   Proceed now to passenger's pick up location.", function () {
                //alert('success');
            }, function (reason) {
                //alert(reason);
            });


            localStorage.setItem('transaction_id', data.data.data.transaction_id);

            $interval.cancel($scope.expiretimer);
            $scope.requestExpireTimer = true;
            $ionicLoading.hide();
            $scope.startBackgroundGeolocation("0");
            $scope.currentPassenger = JSON.parse(localStorage.getItem('currentPassenger'));
            $scope.currentPassengerUserId = $scope.currentPassenger.user_id;
            $scope.smsTemplate = "BOOKING NO: " + $scope.currentPassenger.booking_id +
                "%0aDRIVER: " + $scope.profile.full_name + "%0a%0a";


            $driverAppService.changeDriverStatus({
                status: 0
            }, function (response) {

                if (response.status == 204) {
                    $scope.showToggle = false;
                    $scope.targetLocationDisplay = $scope.currentPassenger.p_location;

                    $scope.startBackgroundGeolocation(0);

                }
            });



        } else if (data.status == 0) { //needed
            //alert('else part');
            $scope.currentPassengerUserId = 0;
            $ionicLoading.hide();
            $scope.cabStatus = EMPTY;
            $leafletService.removeMarker($scope.map, $scope.passMarker);
            $interval.cancel($scope.display);
            $scope.request = [];
            $scope.displayCounter = $scope.displayTimeLimit;
            $scope.startQueueingBookingList();
            $ionicLoading.show({
                template: '<h3>' + data.message + '</h3>',
                noBackdrop: true
            });

            $timeout(function () {
                $ionicLoading.hide();
                $ionicLoading.hide();
                localStorage.removeItem('currentPassenger');
            }, 3100);
        }
    }

    $scope.bookingCancelledByPassenger = function (data) {
        $databaseService.deleteBooking(data.booking_id,
            function (res) {
                if (res.rowsAffected > 0) {
                    if (data.booking_id == $scope.request[0].booking_id) {
                        if ($scope.hasPassenger == 1) {
                            $ionicLoading.hide();
                            $scope.hasPassenger = 0;
                            if ($scope.passMarker != undefined)
                                $leafletService.removeMarker($scope.map, $scope.passMarker);
                        }

                        $interval.cancel($scope.display);
                        $scope.request = [];
                        $scope.displayCounter = $scope.displayTimeLimit;
                        $scope.startQueueingBookingList();

                        $ionicLoading.show({
                            template: '<h3>Booking Number <br/>' + data.booking_id + '<br/> is canceled by Passenger!</h3>',
                            noBackdrop: true
                        });

                        $timeout(function () {
                            $ionicLoading.hide();
                        }, 3100);

                    } else {
                        $interval.cancel($scope.display);
                        $scope.request = [];
                        $scope.displayCounter = $scope.displayTimeLimit;
                        $scope.startQueueingBookingList();
                    }
                }

            },
            function (e) {
                //alert(JSON.stringify(e));
                console.log(e);
            });
    }

    $scope.showActionsheet = function () {

        $ionicActionSheet.show({
            titleText: 'Driver Menu',
            buttons: [
                {
                    text: '<i class="icon ion-wrench dark"></i>Trouble Status'
                },
                {
                    text: '<i class="icon ion-android-exit dark"></i> Logout'
                }
      ],

            buttonClicked: function (index) {
                switch (index) {
                case 0:
                    $scope.statusTrouble();
                    break;
                case 1:
                    $scope.showLogoutDialog();
                    break;
                }
                return true;
            }

        });
    };

    $scope.modal = null;

    $scope.loadModal = function ($template) {
        $ionicModal.fromTemplateUrl($template, {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
            $scope.openModal();
        });


    }

    $scope.openModal = function () {
        $scope.modal.show();
    }

    $scope.closeModal = function () {
        $scope.modal.hide();
    }

    $scope.showProfile = function () {

        $scope.loadModal('partials/profile.html');

    }

    $scope.showPassengerProfile = function () {

        $scope.loadModal('partials/passengerProfile.html');

    }

    $scope.exitApplication = function () {

        var confirmPopup = $ionicPopup.confirm({
            title: 'Are you sure you want to exit?',
            template: ' ',
            okText: 'YES',
            okType: 'button-positive button-clear',
            cancelText: 'NO',
            cancelType: 'button-assertive button-clear'
        });
        confirmPopup.then(function (res) {
            if (res) {
                $socketService.disconnect_socket();
                navigator.app.exitApp();
            }
        });

    }

    $scope.showLogoutDialog = function () {
        if ($scope.isConnected) {
            if ($scope.currentPassengerUserId == 0 && $scope.statusMessage != 'Your are in danger!') {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Logout',
                    template: 'Are you sure you want to logout?',
                    okText: 'LOGOUT',
                    okType: 'button-positive button-clear',
                    cancelText: 'CANCEL',
                    cancelType: 'button-positive button-clear'
                });
                confirmPopup.then(function (res) {
                    if (res)
                        $scope.logoutDriver();

                });
            } else {
                var msg = "You have on going transaction";
                if ($scope.statusMessage == 'DangerYour are in danger!')
                    msg = "You are in Danger. Cannot Logout ";

                $ionicPopup.alert({
                    title: 'Logout failed',
                    template: msg,
                    okType: 'button-positive button-clear'
                });

            }
        } else {
            $ionicLoading.show({
                template: 'No network available in your area. Please try again later..',
                noBackdrop: true
            });
            $timeout(function () {
                $ionicLoading.hide();
            }, 4000)
        }
    }

    $scope.logoutDriver = function () {

        var dependency = $driverAppService.get_dependency();

        $apiCaller.delete("auths", localStorage.getItem("session_id"),
            function (response) {
                if (response.status == 202) {
                    localStorage.clear();
                    sessionStorage.clear();
                    navigator.app.exitApp();
                }
            }, dependency);
    }

}
