function ratingController($scope, $ratingService, $ionicPopup, $cordovaVibration, $moveJSService, $timeout, $interval, $databaseService, $cordovaNativeAudio, $driverAppService, $ionicLoading, $ionicModal, $socketService) {


	$scope.transaction = JSON.parse(localStorage.getItem('transaction'));
	$scope.currentPassenger = JSON.parse(localStorage.getItem('currentPassenger'));
	$scope.data = [];
	$scope.data.rate = 0;
	$scope.destination = "Loading destination...";
	$scope.pickUpLocation = "Loading pickup location...";
	var myPopup;

	$scope.init = function () {

		$moveJSService.loadActivity("rating", function () {

		});
		$scope.duration();
		$scope.getPickupAddress($scope.transaction.p_lat, $scope.transaction.p_lng);
		$scope.getDestinationAddress($scope.transaction.d_lat, $scope.transaction.d_lng);



	}


	$scope.duration = function () {

		var seconds = $scope.transaction.travel_duration;
		// multiply by 1000 because Date() requires miliseconds
		var date = new Date(seconds * 1000);
		var hh = date.getUTCHours();
		var mm = date.getUTCMinutes();
		var ss = date.getSeconds();
		// If you were building a timestamp instead of a duration, you would uncomment the following line to get 12-hour (not 24) time
		// if (hh > 12) {hh = hh % 12;}
		// These lines ensure you have two-digits
		if (hh < 10) {
			hh = "0" + hh;
		}
		if (mm < 10) {
			mm = "0" + mm;
		}
		if (ss < 10) {
			ss = "0" + ss;
		}
		// This formats your string to HH:MM:SS
		$scope.travelDuration = hh + ":" + mm + ":" + ss;
		$scope.$apply();
	}


	$scope.doneTransaction = function () {
		var template = ' <center> <img src =' + $scope.currentPassenger.image + ' style="max-width:85px; border-radius:100%;"/> <br/>' +
			'<h2>' + $scope.currentPassenger.given_name + ' ' + $scope.currentPassenger.last_name + '</h2><br/>' +
			'<rating ng-model="data.rate" max="5" ></rating></center>';

		myPopup = $ionicPopup.show({
			template: template,
			title: 'Rate Passenger',
			subTitle: '',
			scope: $scope,
			buttons: [
				{
					text: 'CANCEL',
					type: 'button-positive button-clear',
				},
				{
					text: 'CONTINUE',
					type: 'button-positive button-clear',
					onTap: function (e) {
						if ($scope.data.rate == 0) {
							e.preventDefault();

							$ionicPopup.alert({
								title: 'Operation required',
								template: 'You are required to rate the passenger',
								okType: 'button-positive button-clear'
							}).then(function () {
								//$scope.doneTransaction();
							});

						} else {
							$scope.ratePassenger();
						}
					}
				}
			]
		});


	}


	$scope.ratePassenger = function () {

		var data = {
			"user_id": $scope.currentPassenger.user_id,
			"rating": $scope.data.rate
		};

		$ratingService.addRating(data,
			function (response) {
				myPopup.close();
				if (response.status == 201) {

					localStorage.removeItem('currentPassenger');
					localStorage.removeItem('transaction');
					localStorage.removeItem('transaction_id');
					$ionicLoading.show({
						template: 'Transaction Complete!',
						noBackdrop: true
					});



					$timeout(function () {
						$ionicLoading.hide();
						window.location = "#/main";
					}, 3000);


				} else {

					$ionicPopup.alert({
						title: 'Operation required',
						template: 'You are required to rate the passenger',
						okType: 'button-positive button-clear'

					}).then(function () {
						$scope.doneTransaction();
					});

				}

			});
	}


	$scope.getPickupAddress = function (lat, lng) {
		var geocoder = new google.maps.Geocoder();
		var latlng = new google.maps.LatLng(lat, lng);
		geocoder.geocode({
			'location': latlng
		}, function (results, status) {
			$scope.pickUpLocation = results[0].formatted_address;
			$scope.$apply();
		});
	}

	$scope.getDestinationAddress = function (lat, lng) {
		var geocoder = new google.maps.Geocoder();
		var latlng = new google.maps.LatLng(lat, lng);
		geocoder.geocode({
			'location': latlng
		}, function (results, status) {
			$scope.destination = results[0].formatted_address;
			$scope.$apply();

		});
	}

}