document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
	initializeMenuButton();
	initializeBackButton();
}

/*
 *  Author: Jerone Altura
 *  File: hardwareKeys.js
 */

var menuButtonCallBackFunction = function () {};
var backButtonCallBackFunction = function () {};

/*
 *  Initialize menu button trigger event
 */
function initializeMenuButton() {
	document.addEventListener("menubutton", onMenuButton, false);
}

function onMenuButton() {
	menuButtonCallBackFunction();
}

/*
 *  Overides Menu Button call back function
 */

function registerMenuButtonCallBackFunction(callback) {
	menuButtonCallBackFunction = '';
	menuButtonCallBackFunction = callback;
}

/*
 *  Clear Menu Button call back function
 */
function clearMenuButton() {
	menuButtonCallBackFunction = function () {};
}

/*
 * initialize back button trigger event
 */
function initializeBackButton() {
	document.addEventListener("backbutton", onBackButton, false);
}

function onBackButton() {
	backButtonCallBackFunction();
	preventDefault();
}

/*
 *  Overides Back Button call back function
 */
function registerBackButtonCallBackFunction(callback) {
	backButtonCallBackFunction = callback;
}

/*
 *  Clear Back Button call back function
 */
function clearBackButton() {
	backButtonCallBackFunction = function () {};
}
