function bgGeolocationService($cordovaBackgroundGeolocation, $apiCaller) {

    this.startBackgroundGeolocation = function (obj) {
        console.log(JSON.stringify(obj));
        this.stopBackgroundGeolocation();
        //console.log(JSON.stringify(obj));
        var options = {
            locationUpdateInterval: 500,
            url: $apiCaller.backgroundGeolocationUrl, // <-- Android ONLY:  your server url to send locations to
            params: {
                access_token: obj.access_token,
                device_id: obj.device_id,
                location_id: obj.location_id,
                status: obj.status
            },
            headers: {},
            autoSync: true,
            desiredAccuracy: 0,
            stationaryRadius: 10,
            distanceFilter: 1,
            notificationTitle: 'MGE TAXI', // <-- android only, customize the title of the notification
            notificationText: 'Geolocation', // <-- android only, customize the text of the notification
            activityType: 'AutomotiveNavigation',
            debug: false, //true, // <-- enable this hear sounds for background-geolocation life-cycle.
            stopOnTerminate: true
        };
        localStorage.setItem('status', obj.status);
        $cordovaBackgroundGeolocation.configure(options)
            .then(null, // Background never resolves
                function (err) { // error callback
                    console.error(err);
                },
                function (location) { // notify callback
                    console.log(location);

                });

    }

    this.stopBackgroundGeolocation = function () {
        $cordovaBackgroundGeolocation.stop();
    };

}
