function databaseService() {

	/*
	 * Global database call
	 */
	this.db = null;

	this.initializeDB = function () {
		this.db = window.sqlitePlugin.openDatabase({
			name: "bookings.db"
		});
		this.createTable();
	}

	/*
		Sqlite datebase create table bookings
	*/
	this.createTable = function () {
		this.db.transaction(function (tx) {
			this.db.transaction(function (tx) {
				tx.executeSql('DROP TABLE IF EXISTS booking');
				tx.executeSql('CREATE TABLE IF NOT EXISTS booking (booking_id integer primary key, passenger_id integer,ratings integer ,mobile_number text, user_id integer,image text,last_name text,given_name text,o_location text,o_city text,o_region text,o_country text,o_lat text,o_lng text,p_location text,p_city text,p_region text,p_country text,p_lat text,p_lng text,d_location text,d_city text,d_region text,d_country text,d_lat text,d_lng text,status integer,datetime_added text,datetime_updated text)');

				this.db.executeSql("pragma table_info (test_table);", [], function (res) {

				});
			})
		}, function (e) {
			console.log("ERROR: " + e.message);
		});

	}


	this.addBookingData = function (data) {
		console.log('::addBookingData -> new booking');
		console.log(data);
		this.db = window.sqlitePlugin.openDatabase({
			name: "bookings.db"
		});

		this.db.transaction(function (tx) {
				var that = this;

				tx.executeSql(
					"INSERT INTO booking (booking_id, passenger_id, user_id,  image,  last_name, given_name,ratings,mobile_number , o_location,  o_city, o_region, o_country,  o_lat,  o_lng, p_location, p_city, p_region, p_country, p_lat, p_lng,  d_location,  d_city,  d_region,  d_country,  d_lat,  d_lng,  status,  datetime_added,  datetime_updated) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", [data.booking_id,
                     data.passenger.passenger_id,
                     data.passenger.user_id,
                     data.passenger.imagemedium,
                     data.passenger.last_name,
                     data.passenger.given_name,
					 data.passenger.ratings,
					 data.passenger.mobile_number,
                     data.o_location,
                     data.o_city,
                     data.o_region,
                     data.o_country,
                     data.o_lat,
                     data.o_lng,
                     data.p_location,
                     data.p_city,
                     data.p_region,
                     data.p_country,
                     data.p_lat,
                     data.p_lng,
                     data.d_location,
                     data.d_city,
                     data.d_region,
                     data.d_country,
                     data.d_lat,
                     data.d_lng,
                     data.status,
                     data.datetime_added,
                     data.datetime_updated]);

			},
			function (err) {
				console.log(err)
			});
	}


	this.errorEvent = function (e) {
		console.log("ERROR: " + e.message);
	}


	this.getBookingData = function (successEvent, errorEvent) {

		this.db.transaction(function (tx) {
			var that = this;
			tx.executeSql("select * from booking where status = 0 order by booking_id asc", [], function (tx, res) {
				// console.log(res.rows.length);
				if (res.rows.length == 0) {
					errorEvent();
				} else {
					var data = '[' + JSON.stringify(res.rows.item(0)) + ']';
					successEvent(JSON.parse(data));

				}

			});
		});
	}


	this.updateBookingStatus = function (booking_id, status, successEvent, errorEvent) {
		this.db.transaction(function (tx) {
			tx.executeSql("UPDATE booking SET status= ? where booking_id = ? ", [status, booking_id],
				function (tx, res) {
					successEvent();
				},
				function (e) {
					alert(e.message);
				})
		});
	}

	this.deleteBooking = function (booking_id, successEvent, errorEvent) {
		this.db.transaction(function (tx) {
			tx.executeSql("DELETE from booking where booking_id = ? ", [booking_id],
				function (tx, res) {

					successEvent(res);
				},
				function (e) {
					errorEvent(e);
				})
		});
	}

}