function driverAppService($apiCaller, $cordovaDevice, $cordovaGeolocation, $ionicLoading, $socketService) {


    this.get_dependency = function () {
        var device_info = $cordovaDevice.getDevice();
        return {
            "access_token": localStorage.getItem('access_token'),
            "device_id": device_info.uuid
        };
    }

    this.geoOption = {
        timeout: 10000,
        enableHighAccuracy: true
    };


    this.checkGpsStatus = function (sucessEvent, errorEvent) {
        $cordovaGeolocation
            .getCurrentPosition({
                timeout: 10000,
                enableHighAccuracy: false
            })
            .then(function (position) {
                sucessEvent(position);
            }, function (err) {
                errorEvent(err);
            });
    }

    this.fetchLocationInfo = function (successEvent, errorEvent) {

        var dependency = this.get_dependency();
        var cab = JSON.parse(localStorage.getItem("cab"));
        var access = JSON.parse(localStorage.getItem("appAccessObj"));
        var profile = JSON.parse(localStorage.getItem("profile"));
        var that = this;

        $apiCaller.create("cab-locations", {
            "cab_id": cab.cab_id,
            "session_id": access.session_id,
            "driver_id": profile.driver_id,
            "lat": sessionStorage.getItem('currentlat'),
            "lng": sessionStorage.getItem('currentlng')
        }, function (response) {
            $ionicLoading.hide();
            if (response.status == 201) {
                localStorage.setItem('location_id', response.data.location_id);
                successEvent();
            } else {
                errorEvent(response);
            }
        }, dependency);


    }

    this.parseAddressComponents = function (obj) {

        var result = {};
        for (x = 0; x < obj.length; x++) {
            if (obj[x].types.indexOf('locality') > -1) {
                result.city = obj[x].long_name;
            }
            if (obj[x].types.indexOf('administrative_area_level_1') > -1) {
                result.region = obj[x].long_name;

            }
            if (obj[x].types.indexOf('country') > -1) {
                result.country = obj[x].long_name;

            }

        }
        return result;
    }

    this.fetchBookingfromServer = function (data, successEvent, errorEvent) {
        var dependency = this.get_dependency();

        $apiCaller.get("bookings",
            data.data.booking_id, {
                expand: "passenger"
            },
            function (response) {

                if (response.status == 200) {
                    if (response.data.status == '0')
                        successEvent(response.data);

                } else {
                    errorEvent();
                }
            },
            dependency
        );
    }

    this.returnFromHomeScreen = function () {
        navigator.startApp.start("com.mgetaxi.driver", function (message) {
                console.log(message); // => OK
            },
            function (error) { /* error */
                console.log(error);
            })
    }


    this.changeDriverStatus = function (data, callback) {
        var dependency = this.get_dependency();

        var location_id = localStorage.getItem('location_id');
        $apiCaller.update("cab-locations",
            location_id,
            data,
            function (e) {
                callback(e);
            }, dependency
        );
    }


    this.generateDriverCode = function (id) {

        return (("0").toString().repeat(4 - (id).toString().length)) + (id).toString();

    }


    this.updateBookingTransaction = function (transaction_id, data, callback) {
        var dependency = this.get_dependency();

        $apiCaller.update("transactions",
            transaction_id,
            data,
            function (e) {
                callback(e);
            }, dependency
        );


    }

}