function leafletService() {

    this.loadMap = function (mapData) {

        var map = L.map(mapData.mapContainer).setView([mapData.lat, mapData.lng], mapData.zoom);

//        var map_here = L.tileLayer('http://{s}.{base}.maps.cit.api.here.com/maptile/2.1/maptile/{mapID}/normal.day/{z}/{x}/{y}/256/png8?app_id={app_id}&app_code={app_code}', {
//            attribution: 'Map &copy; 1987-2014 <a href="http://developer.here.com">HERE</a>',
//            subdomains: '1234',
//            mapID: 'newest',
//            app_id: 'Y8m9dK2brESDPGJPdrvs',
//            app_code: 'dq2MYIvjAotR8tHvY8Q_Dg',
//            base: 'base'
//        });

        try {
          //  var Thunderforest = L.tileLayer('http://{s}.tile.thunderforest.com/transport/{z}/{x}/{y}.png', {});
            var googleLayer = new L.Google('ROADMAP');
            map.addLayer(googleLayer);
        }catch(e){
            alert(e);
        }

        return map;
    }


    this.addMarker = function (mapData) {

        var markerIcon = L.icon({
            iconUrl: mapData.icon,
            iconSize: [mapData.size, mapData.size],
        });

        var marker = new L.marker([mapData.lat, mapData.lng], {
            icon: markerIcon
        });

        return marker;
    }


    this.removeMarker = function (map, markers) {

        map.removeLayer(markers);

        return null;
    }

    this.setCenter = function (mapData) {
        mapData.mapContainer.setView([mapData.lat, mapData.lng], mapData.zoom);
    }


    this.getMidPoint = function (x1, y1, x2, y2) {
        var x = (x1 + x2) / 2;
        var y = (y1 + y2) / 2;
        return {
            lat: x,
            lng: y
        };
    }
}