function socketService() {

    this.socketUrl = 'https://mgetaxi.com:3000';
    this.server_token = '700c308afb6ef7e32b3b48b0626b449a';
    this.socket = '';
    // code dictionary
    var coder = {
        'authenticate': '2510',
        'response': '1BFE',
        'disconnect_client': '89BD',
        'connect_driver': '1FE2',
        'new_booking': 'D43E',
        'driver_location': '0ABC',
        'update_booking_acceptance': '03D5',
        'cancel_booking': '2691',
        'booking_sent': 'EB07'
    };


    var response_code = {

        'save_auth': function (data) {
            localStorage.setItem('socket_session_key', data.socket_session_key);

        },
        'authentication_error': function (data) {
            alert(data.error_message);
        },
        'accept_booking': function (data) {
            alert(JSON.stringify(data));
        },
        'new_booking': function (data) {
            alert('new_booking:: ' + JSON.stringify(data));
        },
        'cancel_booking': function (data) {
            alert('cancel_booking:: ' + JSON.stringify(data));
        },
        'update_booking_acceptance': function (data) {


        },
        'passenger_response': function (data) {
            alert('passenger_response:: ' + JSON.stringify(data));
        },
        'pickup_request_sent': function (data) {
            alert('pickup_request_sent:: ' + JSON.stringify(data));
        }


    }


    this.set_socket_response = function (action, event) {
        response_code[action] = '';
        response_code[action] = event;
    }


    this.socket_session = function () {
        var access_token = localStorage.getItem('access_token');
        var profile = JSON.parse(localStorage.getItem('profile'));
        var socket_session_key = localStorage.getItem('socket_session_key');
        return {
            socket_session_key: socket_session_key,
            access_token: access_token,
            user_id: profile.user_id,
            session_type: 'D'
        }
    }


    this.connect_socket = function () {
        this.socket = io.connect(this.socketUrl);
    }


    this.response = function () {
        var profile = JSON.parse(localStorage.getItem('profile'));
        this.socket.on(profile.user_id, function (response) {
            response_code[response.action](response.data);
            //console.log(':: ' + response.action + ' Executed');
            //console.log(':: Data: ' + JSON.stringify(response.data));
        });
    }


    this.authenticate = function () {
        var access_token = localStorage.getItem('access_token');
        var profile = JSON.parse(localStorage.getItem('profile'));
        var data = {
            'server_token': this.server_token,
            'access_token': access_token,
            'user_id': profile.user_id,
            'session_type': 'D'
        };
        this.socket.emit('2510', data); //'authenticate'

    }

    this.socket_init = function () {
        this.connect_socket();
        this.response();
        this.authenticate();
    }


    this.disconnect_socket = function () {
        var session = this.socket_session();
        var obj = {
            auth: session
        }
        this.socket.emit('89BD', obj);
    }


    this.update_booking_acceptance = function (booking_details, callback) {

        this.set_socket_response('update_booking_acceptance', callback);

        var session = this.socket_session();
        var obj = {
            auth: session,
            data: {
                status: booking_details.status,
                booking_id: booking_details.booking_id,
                user_id: booking_details.user_id,
                location_id: booking_details.location_id,
                r_lat: booking_details.r_lat,
                r_lng: booking_details.r_lng,
                cab_id: booking_details.cab_id
            }

        }
        this.socket.emit('03D5', obj);

    }


    this.send_location_to_server = function (data) {
        var session = this.socket_session();
        var obj = {
            auth: session,
            data: data
        }
        this.socket.emit('0ABC', obj);
    }


    this.pickup_passanger = function (data) {

        var session = this.socket_session();
        var obj = {
            auth: session,
            data: data
        }
        this.socket.emit('1176', obj);
    }

    this.transaction_done = function (data) {

        var session = this.socket_session();
        var obj = {
            auth: session,
            data: data
        }
        this.socket.emit('7062', obj);
    }



}
